## ccache 4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3)

project(ccache LANGUAGES C CXX)
if(MSVC)
  enable_language(ASM_MASM)
else()
  enable_language(ASM)
endif()
set(CMAKE_PROJECT_DESCRIPTION "a fast C/C++ compiler cache")

if(NOT "${CMAKE_CXX_STANDARD}")
  set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED YES)
set(CMAKE_C_EXTENSIONS NO)

# Always export compile_commands.json since it's useful for many tools.
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Minimum compiler requirements (fail gracefully instead of producing cryptic
# C++ error messages)
#

# Clang 3.4 and AppleClang 6.0 fail to compile doctest.
# GCC 4.8.4 is known to work OK but give warnings.
if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.4)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0))
  message(
    FATAL_ERROR
    "The compiler you are using is too old, sorry.\n"
    "You need one listed here: https://ccache.dev/platform-compiler-language-support.html")
endif()

# All Clang problems / special handling ccache has are because of version 3.5.
# All GCC problems / special handling ccache has are because of version 4.8.4.
if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.6)
    OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0))
  message(
    WARNING
    "The compiler you are using is rather old.\n"
    "If anything goes wrong you might be better off with one listed here:"
    " https://ccache.dev/platform-compiler-language-support.html")

  # Warnings from old compilers are probably useless anyway.
  option(WARNINGS_AS_ERRORS "Treat compiler warnings as errors" FALSE)
endif()

#
# Settings
#
include(CcacheVersion)

if("${CCACHE_VERSION_ORIGIN}" STREQUAL git OR DEFINED ENV{CI})
  set(CCACHE_DEV_MODE ON)
else()
  set(CCACHE_DEV_MODE OFF)
endif()
message(STATUS "Ccache dev mode: ${CCACHE_DEV_MODE}")

include(UseCcache)
include(UseFastestLinker)
include(StandardSettings)
include(StandardWarnings)
include(CIBuildType)
include(DefaultBuildType)

if(NOT ${CMAKE_VERSION} VERSION_LESS "3.9")
  cmake_policy(SET CMP0069 NEW)
  option(ENABLE_IPO "Enable interprocedural (link time, LTO) optimization" OFF)
  if(ENABLE_IPO)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
  endif()
endif()

#
# Configuration
#
include(GNUInstallDirs)
include(GenerateConfigurationFile)
include(GenerateVersionFile)

if(HAVE_SYS_MMAN_H AND HAVE_PTHREAD_MUTEXATTR_SETPSHARED)
  set(INODE_CACHE_SUPPORTED 1)
endif()

#
# Third party
#
set(ZSTD_FROM_INTERNET_DEFAULT OFF)

# Default to downloading deps for Visual Studio, unless using a package manager.
if(MSVC AND NOT CMAKE_TOOLCHAIN_FILE MATCHES "vcpkg|conan")
  set(ZSTD_FROM_INTERNET_DEFAULT ON)
endif()

option(ZSTD_FROM_INTERNET "Download and use libzstd from the Internet" ${ZSTD_FROM_INTERNET_DEFAULT})
find_package(zstd 1.1.2 REQUIRED)

#
# Special flags
#
# Note: Cppcheck will scan everything after this point. zstd is above so it
# doesn't get scanned.
#
include(CodeAnalysis)
option(ENABLE_TRACING "Enable possibility to use internal ccache tracing" OFF)

if(WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  option(STATIC_LINK "Link statically with system libraries" ON)
endif()

#
# Source code
#
add_subdirectory(src)

#
# ccache executable
#
add_executable(ccache src/main.cpp)
target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_lib)

#
# Documentation
#
add_subdirectory(doc)

#
# Installation
#
install(TARGETS ccache DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Packaging
#
include(CcachePackConfig)

#
# Tests
#
option(ENABLE_TESTING "Enable tests" ON)
if(ENABLE_TESTING)
  enable_testing()
  add_subdirectory(unittest)
  add_subdirectory(test)

  # Note: VERSION_GREATER_EQUAL requires CMake 3.17
  if(NOT ${CMAKE_VERSION} VERSION_LESS "3.17")
    list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
  endif()

  # Add "check" target which compiles and runs tests.
  set(
    check_command
    ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure)
  if(CMAKE_CONFIGURATION_TYPES)
    list(APPEND check_command --build-config "$<CONFIGURATION>")
  endif()
  add_custom_target(
    check
    COMMAND ${check_command}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS ccache unittest)
endif()

#
# Special formatting targets
#
find_program(
  CLANG_FORMAT_EXE
  NAMES "clang-format"
  DOC "Path to clang-format executable.")
mark_as_advanced(CLANG_FORMAT_EXE) # Don't show in CMake UIs

if(NOT CLANG_FORMAT_EXE)
  message(STATUS "clang-format not found")
else()
  add_custom_target(
    format
    COMMAND misc/format-files --all
    COMMENT "Formatting code"
    USES_TERMINAL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

  add_custom_target(
    check_format
    COMMAND misc/format-files --all --check
    COMMENT "Checking code formatting"
    USES_TERMINAL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

=== doc/CMakeLists.txt ===
find_program(ASCIIDOC_EXE asciidoc)
mark_as_advanced(ASCIIDOC_EXE) # Don't show in CMake UIs

if(NOT ASCIIDOC_EXE)
  message(NOTICE "Could not find asciidoc; documentation will not be generated")
else()
  #
  # HTML documentation
  #
  function(generate_html adoc_file)
    get_filename_component(base_name "${adoc_file}" NAME_WE)
    set(html_file "${base_name}.html")
    add_custom_command(
      OUTPUT "${html_file}"
      COMMAND
        ${ASCIIDOC_EXE}
          -o "${html_file}"
          -a revnumber="${CCACHE_VERSION}"
          -a toc
          -b xhtml11
          "${CMAKE_SOURCE_DIR}/${adoc_file}"
      MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/${adoc_file}"
    )
    set(html_files "${html_files}" "${html_file}" PARENT_SCOPE)
  endfunction()

  generate_html(LICENSE.adoc)
  generate_html(doc/AUTHORS.adoc)
  generate_html(doc/MANUAL.adoc)
  generate_html(doc/NEWS.adoc)

  add_custom_target(doc-html DEPENDS "${html_files}")
  set(doc_files "${html_files}")

  #
  # Man page
  #
  find_program(A2X_EXE a2x)
  mark_as_advanced(A2X_EXE) # Don't show in CMake UIs
  if(NOT A2X_EXE)
    message(WARNING "Could not find a2x; man page will not be generated")
  else()
    # MANUAL.adoc -> MANUAL.xml -> man page
    add_custom_command(
      OUTPUT MANUAL.xml
      COMMAND
        ${ASCIIDOC_EXE}
          -o -
          -a revnumber=${CCACHE_VERSION}
          -d manpage
          -b docbook "${CMAKE_SOURCE_DIR}/doc/MANUAL.adoc"
        | perl -pe 's!<literal>\(.*?\)</literal>!<emphasis role="strong">\\1</emphasis>!g'
            >MANUAL.xml
      MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/doc/MANUAL.adoc"
    )
    add_custom_command(
      OUTPUT ccache.1
      COMMAND ${A2X_EXE} --doctype manpage --format manpage MANUAL.xml
      MAIN_DEPENDENCY MANUAL.xml
    )
    add_custom_target(doc-man-page DEPENDS ccache.1)
    install(
      FILES "${CMAKE_CURRENT_BINARY_DIR}/ccache.1"
      DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    )
    set(doc_files "${doc_files}" ccache.1)
  endif()

  add_custom_target(doc ALL DEPENDS "${doc_files}")
endif()

=== src/CMakeLists.txt ===
set(
  source_files
  Args.cpp
  AtomicFile.cpp
  CacheEntryReader.cpp
  CacheEntryWriter.cpp
  CacheFile.cpp
  Compression.cpp
  Compressor.cpp
  Config.cpp
  Context.cpp
  Counters.cpp
  Decompressor.cpp
  Depfile.cpp
  Hash.cpp
  Lockfile.cpp
  Logging.cpp
  Manifest.cpp
  MiniTrace.cpp
  NullCompressor.cpp
  NullDecompressor.cpp
  ProgressBar.cpp
  Result.cpp
  ResultDumper.cpp
  ResultExtractor.cpp
  ResultRetriever.cpp
  SignalHandler.cpp
  Stat.cpp
  Statistics.cpp
  TemporaryFile.cpp
  ThreadPool.cpp
  Util.cpp
  ZstdCompressor.cpp
  ZstdDecompressor.cpp
  argprocessing.cpp
  assertions.cpp
  ccache.cpp
  cleanup.cpp
  compopt.cpp
  compress.cpp
  execute.cpp
  hashutil.cpp
  language.cpp
  version.cpp)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files Win32Util.cpp)
endif()

add_library(ccache_lib STATIC ${source_files})
target_compile_definitions(
  ccache_lib PUBLIC -Dnssv_CONFIG_SELECT_STRING_VIEW=nssv_STRING_VIEW_NONSTD
)

if(WIN32)
  target_link_libraries(ccache_lib PRIVATE ws2_32 "psapi")

  if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(STATIC_LINK)
      target_link_libraries(ccache_lib PRIVATE -static-libgcc -static-libstdc++ -static winpthread -dynamic)
    else()
      target_link_libraries(ccache_lib PRIVATE winpthread)
    endif()
  elseif(STATIC_LINK AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_link_libraries(ccache_lib PRIVATE -static c++ -dynamic)
  endif()
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(
  ccache_lib
  PRIVATE standard_settings standard_warnings ZSTD::ZSTD
          Threads::Threads third_party_lib)

target_include_directories(ccache_lib PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(third_party)

=== test/CMakeLists.txt ===
function(addtest name)
  add_test(
    NAME "test.${name}"
    COMMAND bash ${CMAKE_SOURCE_DIR}/test/run ${name}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
  set_tests_properties(
    "test.${name}"
    PROPERTIES
    ENVIRONMENT "CCACHE=${CMAKE_BINARY_DIR}/ccache;EXIT_IF_SKIPPED=true")

  if(${CMAKE_VERSION} VERSION_LESS "3.9")
    # Older CMake versions treat skipped tests as errors. Therefore, resort to
    # parsing output for those cases (exit code is not considered). Skipped
    # tests will appear as "Passed".
    set_tests_properties(
      "test.${name}"
      PROPERTIES
      PASS_REGULAR_EXPRESSION "PASSED|Passed|Skipped"
      FAIL_REGULAR_EXPRESSION "[Ww]arning|[Ff]ail|[Er]rror")
  else()
    set_tests_properties("test.${name}" PROPERTIES SKIP_RETURN_CODE 125)
  endif()

endfunction()

if(${CMAKE_VERSION} VERSION_LESS "3.15")
  set(clean_files_prop_name ADDITIONAL_MAKE_CLEAN_FILES)
else()
  set(clean_files_prop_name ADDITIONAL_CLEAN_FILES)
endif()
set_property(
  DIRECTORY PROPERTY
  ${clean_files_prop_name} "${CMAKE_BINARY_DIR}/testdir")

addtest(base)
addtest(basedir)
addtest(cache_levels)
addtest(cleanup)
addtest(color_diagnostics)
addtest(cpp1)
addtest(debug_prefix_map)
addtest(depend)
addtest(direct)
addtest(direct_gcc)
addtest(fileclone)
addtest(hardlink)
addtest(inode_cache)
addtest(input_charset)
addtest(masquerading)
addtest(modules)
addtest(multi_arch)
addtest(no_compression)
addtest(nocpp2)
addtest(nvcc)
addtest(nvcc_direct)
addtest(nvcc_ldir)
addtest(nvcc_nocpp2)
addtest(pch)
addtest(profiling)
addtest(profiling_clang)
addtest(profiling_gcc)
addtest(profiling_hip_clang)
addtest(readonly)
addtest(readonly_direct)
addtest(sanitize_blacklist)
addtest(serialize_diagnostics)
addtest(source_date_epoch)
addtest(split_dwarf)
addtest(upgrade)

=== unittest/CMakeLists.txt ===
set(
  source_files
  TestUtil.cpp
  main.cpp
  test_Args.cpp
  test_AtomicFile.cpp
  test_Checksum.cpp
  test_Compression.cpp
  test_Config.cpp
  test_Counters.cpp
  test_Depfile.cpp
  test_FormatNonstdStringView.cpp
  test_Hash.cpp
  test_Lockfile.cpp
  test_NullCompression.cpp
  test_Stat.cpp
  test_Statistics.cpp
  test_Util.cpp
  test_ZstdCompression.cpp
  test_argprocessing.cpp
  test_ccache.cpp
  test_compopt.cpp
  test_hashutil.cpp)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files test_InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files test_bsdmkstemp.cpp test_Win32Util.cpp)
endif()

add_executable(unittest ${source_files})

target_link_libraries(
  unittest
  PRIVATE standard_settings standard_warnings ccache_lib third_party_lib)

target_include_directories(unittest PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${ccache_SOURCE_DIR}/src)

add_test(NAME unittest COMMAND unittest)

=== src/third_party/CMakeLists.txt ===
add_library(third_party_lib STATIC base32hex.c format.cpp xxhash.c)
if(NOT MSVC)
  target_sources(third_party_lib PRIVATE getopt_long.c)
else()
  target_sources(third_party_lib PRIVATE win32/getopt.c)
  target_compile_definitions(third_party_lib PUBLIC -DSTATIC_GETOPT)
endif()

if(WIN32)
  target_sources(third_party_lib PRIVATE win32/mktemp.c)
endif ()

if(ENABLE_TRACING)
  target_sources(third_party_lib PRIVATE minitrace.c)
endif()

set(xxhdispatchtest [=[
#include "xxh_x86dispatch.c"

int main()
{
  XXH3_64bits_dispatch("foo", 3);
  return 1;
}
]=])

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c" "${xxhdispatchtest}")

try_compile(USE_XXH_DISPATCH ${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c"
  CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CMAKE_CURRENT_SOURCE_DIR}"
  COMPILE_DEFINITIONS "-DXXH_STATIC_LINKING_ONLY")

target_compile_definitions(third_party_lib INTERFACE "-DXXH_STATIC_LINKING_ONLY")
if(USE_XXH_DISPATCH)
  target_sources(third_party_lib PRIVATE xxh_x86dispatch.c)
  target_compile_definitions(third_party_lib INTERFACE "-DUSE_XXH_DISPATCH")
endif()

# Treat third party headers as system files (no warning for those headers).
target_include_directories(
  third_party_lib
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} SYSTEM)

target_link_libraries(third_party_lib PRIVATE standard_settings)
target_link_libraries(third_party_lib INTERFACE blake3)

# These warnings are enabled by default even without e.g. -Wall, but we don't
# want them in third_party.
if(CMAKE_CXX_COMPILER_ID MATCHES "^GNU|Clang$")
  target_compile_options(
    third_party_lib
    PRIVATE
      $<$<COMPILE_LANGUAGE:C>:-Wno-implicit-function-declaration
      -Wno-int-conversion>)
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  target_compile_options(
    third_party_lib
    PRIVATE $<$<COMPILE_LANGUAGE:C>:-Wno-attributes>)
endif()

# Silence warning from winbase.h due to /Zc:preprocessor.
if(MSVC)
  target_compile_options(
    third_party_lib
    PRIVATE /wd5105)
endif()

# The headers are included from the rest of the project, so turn off warnings as
# required.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(third_party_lib INTERFACE -Wno-shadow)
endif()

add_subdirectory(blake3)

=== src/third_party/blake3/CMakeLists.txt ===
add_library(blake3 STATIC blake3.c blake3_dispatch_ccache.c blake3_portable.c)

target_link_libraries(blake3 PRIVATE standard_settings)

if(MSVC)
  # No object file is created if masm is passed the compile options from standard_settings,
  # so don't pass any flags at all to assembler (as no flags are needed anyway).
  string(REPLACE "<FLAGS> " "" CMAKE_ASM_MASM_COMPILE_OBJECT "${CMAKE_ASM_MASM_COMPILE_OBJECT}")
endif()

include(CheckCSourceCompiles)

function(add_source_if_enabled feature msvc_flags others_flags intrinsic)
  if(MSVC)
    set(compile_flags "${msvc_flags}")
  else()
    set(compile_flags "${others_flags}")
  endif()

  # First check if it's possible to use the assembler variant for the feature.
  string(TOUPPER "have_asm_${feature}" have_feature)
  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(MSVC)
      set(suffix "_x86-64_windows_msvc.asm")
    elseif(WIN32)
      set(suffix "_x86-64_windows_gnu.S")
    else()
      set(suffix "_x86-64_unix.S")
    endif()

    if(NOT CMAKE_REQUIRED_QUIET)
      message(STATUS "Performing Test ${have_feature}")
    endif()

    set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

    # Must set CMAKE_ASM_MASM_CREATE_STATIC_LIBRARY explicitly otherwise try_compile
    # fails, see https://discourse.cmake.org/t/building-lib-file-from-asm-cmake-bug/1959
    try_compile(
      ${have_feature}
      ${CMAKE_CURRENT_BINARY_DIR}
      "${CMAKE_CURRENT_SOURCE_DIR}/blake3_${feature}${suffix}"
      CMAKE_FLAGS -DCMAKE_ASM_MASM_CREATE_STATIC_LIBRARY=${CMAKE_C_CREATE_STATIC_LIBRARY}
      COMPILE_DEFINITIONS ${compile_flags})

    unset(CMAKE_TRY_COMPILE_TARGET_TYPE)

    if(NOT CMAKE_REQUIRED_QUIET)
      if (${${have_feature}})
        message(STATUS "Performing Test ${have_feature} - Success")
      else()
        message(STATUS "Performing Test ${have_feature} - Failed")
      endif()
    endif()
  endif()

  # If the assembler variant didn't work, try the c variant.
  if(NOT ${have_feature})
    string(TOUPPER "have_c_${feature}" have_feature)
    set(suffix ".c")

    set(CMAKE_REQUIRED_FLAGS ${compile_flags})
    check_c_source_compiles(
      [=[
        #include <immintrin.h>
        int main() { ${intrinsic}; return 0; }
      ]=]
      ${have_feature})
    unset(CMAKE_REQUIRED_FLAGS)
  endif()

  if(${have_feature})
    target_sources(blake3 PRIVATE blake3_${feature}${suffix})
    if(suffix STREQUAL ".c")
      if(MINGW AND feature STREQUAL "avx512")
        # Workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65782.
        # Taken from blake3's build.rs.
        set(compile_flags "${compile_flags} -fno-asynchronous-unwind-tables")
      endif()
      set_property(
        SOURCE blake3_${feature}${suffix}
        APPEND PROPERTY COMPILE_FLAGS ${compile_flags})
    elseif(NOT MSVC)
      set_property(
        SOURCE blake3_${feature}${suffix}
        PROPERTY COMPILE_FLAGS ${compile_flags})
    endif()
  else()
    string(TOUPPER "blake3_no_${feature}" no_feature)
    target_compile_definitions(blake3 PRIVATE ${no_feature})
  endif()
endfunction()

# https://software.intel.com/sites/landingpage/IntrinsicsGuide/
add_source_if_enabled(sse2 "" "-msse2"
  "_mm_set1_epi32(42)")
add_source_if_enabled(sse41 "" "-msse4.1"
  "_mm_test_all_ones(_mm_set1_epi32(42))")
add_source_if_enabled(avx2 "/arch:AVX2" "-mavx2"
  "_mm256_abs_epi8(_mm256_set1_epi32(42))")
add_source_if_enabled(avx512 "/arch:AVX512" "-mavx512f -mavx512vl"
  "_mm256_abs_epi64(_mm256_set1_epi32(42))")

# Neon is always available on AArch64
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  # https://developer.arm.com/architectures/instruction-sets/simd-isas/neon/intrinsics
  check_c_source_compiles(
    [=[
      #include <arm_neon.h>
      int main() { vdupq_n_s32(42); return 0; }
    ]=]
    HAVE_NEON)
  if(HAVE_NEON)
    target_sources(blake3 PRIVATE blake3_neon.c)
    target_compile_definitions(blake3 PRIVATE BLAKE3_USE_NEON)
  endif()
endif()

## ccache 3.0.1

=== debian/changelog ===
ccache (3.0.1-1) unstable; urgency=low

  [ Francois Marier ]
  * Remove myself from uploaders

  [ Y Giridhar Appaji Nag ]
  * Support gcc-4.4 - create links in /usr/lib/ccache.  Thanks Andreas Metzler
    <ametzler@downhill.at.eu.org> for the bug report (Closes: #532169)
  * Fix lintian W:debhelper-but-no-misc-depends, add ${misc:Depends} to ccache
    Depends:
  * Please welcome Joel Rosdahl <joel@debian.org>, the upstream maintainer of
    ccache as a co-maintainer.

  [ Joel Rosdahl ]
  * ccache now correctly falls back to the real compiler when -save-temps
    is used. Closes: #498005.
  * The package no longer patches generated files. Closes: #508054.
  * ccache now has support for rewriting absolute paths (see the
    CCACHE_BASEDIR variable). Closes: #523480.
  * The ccache manual has fixed the wording of MD4 being a strong
    cryptographic hash. Closes: #538821.
  * A new upstream release has been packaged. Closes: #580944.
  * Update copyright information in DEP-5 format.
  * Remove obsolete patches.
  * Don't mention the CCACHE_UNIFY option in README.Debian as it's more or
    less obsolete.
  * Add note in README.Debian that the "NFS Issues" only are relevant when
    using CCACHE_HARDLINK.
  * Remove obsolete update-ccache and reference to manage-cache.sh.
  * Update package description.
  * Include upstream NEWS.txt (as upstream changelog.gz), NEWS.html (as
    changelog.html.gz) and manual.html.
  * Add doc-base entry for the ccache manual.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update Standards-Version to 3.9.1 (no changes required).
  * Change watch file to check for the .bz2 version of the archive.

 -- Joel Rosdahl <joel@debian.org>  Wed, 04 Aug 2010 22:41:42 +0200

ccache (2.4-17) unstable; urgency=low

  [ Y Giridhar Appaji Nag ]
  * New patch 15_gcc4.3_warnings to fix gcc 4.3 warnings.  Thanks
    William S Fulton <wsf@fultondesigns.co.uk> for the bug report and
    the patch (Closes: #508046)
  * Refresh all patches to be "git diff" based and to apply cleanly.
  * Update Standards-Version to 3.8.1 (no changes required)

  [ Francois Marier ]
  * Make Y Giridhar Appaji Nag <appaji@debian.org> the maintainer and
    add myself as uploader

 -- Y Giridhar Appaji Nag <appaji@debian.org>  Sun, 22 Mar 2009 22:08:01 +0530

ccache (2.4-16) unstable; urgency=low

  * Fix the documentation references to CCACHE_HARDLINK (patch from Fedora)
  * Add a patch for the HTML docs in the source (from Fedora)
  * Remove reference to compilercache in the description (closes: #498006)
  * Bump Standards-Version to 3.8.0 (no changes)
  * Move packaging to git and update VCS fields

 -- Francois Marier <francois@debian.org>  Sat, 29 Nov 2008 23:53:39 +1300

ccache (2.4-15) unstable; urgency=low

  * Add a new patch which improve the consistency of timestamps on cached
    objects to make sure clean-up is based on least recently used objects.
  * Patch the set_limit call so that non-writable cache directories return
    an error when attempting to size the max(files|size) (closes: #332527)

 -- Francois Marier <francois@debian.org>  Sun, 13 Apr 2008 15:07:05 +1200

ccache (2.4-14) unstable; urgency=low

  * Mention the long options everywhere in the manpage
  * Merge Gentoo patches:
    - respect user's LDFLAGS
    - use utimes() for timestamp if possible

 -- Francois Marier <francois@debian.org>  Sun, 23 Mar 2008 16:30:11 +1300

ccache (2.4-13) unstable; urgency=low

  * Update CACHEDIR.TAG patch to avoid creating the tag file when the
    CCACHE_READONLY environment variable is set. (closes: #464356)
  * Mention the GNU-style long options in the manpage

 -- Francois Marier <francois@debian.org>  Thu, 07 Feb 2008 10:50:42 +1300

ccache (2.4-12) unstable; urgency=low

  * Add symlink for gcc 4.3 (closes: #463590)
  * Add support for the CACHEDIR.TAG spec, thanks to Karl Chen.
    (see http://www.brynosaurus.com/cachedir/)
  * Fix hyphens in manpage (lintian notice)
  * Bump Standards-Version up to 3.7.3 (no changes)
  * Bump debhelper compatibility to 6

 -- Francois Marier <francois@debian.org>  Sat, 02 Feb 2008 10:37:22 +1300

ccache (2.4-11) unstable; urgency=low

  * Add the collab-maint repo to debian/control

 -- Francois Marier <francois@debian.org>  Tue, 20 Nov 2007 15:26:37 +1300

ccache (2.4-10) unstable; urgency=low

  * Document where the patches are from in debian/patches/CREDITS
  * debian/rules:
    - Fixed "make distclean" lintian warning
    - Removed commented-out entries
  * Set debhelper compatibility to 5
  * Add homepage field in debian/control
  * Add symlinks for MinGW (closes: #445782)
  * Bump the version to 5 in the debhelper dependency

 -- Francois Marier <francois@debian.org>  Fri, 19 Oct 2007 16:04:37 +1300

ccache (2.4-9) unstable; urgency=low

  * Add a symlink for gcc 4.2 (closes: #431007)
  * Fix dependencies when using -o (closes: #217713)

 -- Francois Marier <francois@debian.org>  Sat, 30 Jun 2007 17:58:44 +1200

ccache (2.4-8) unstable; urgency=low

  * Enable zlib compression of the cache by default (closes: #409848).
    Thanks to Sami Liedes for suggesting this.
  * Disable ccache when profiling (closes: #215849).
    Thanks to Ted Percival for the Patch.
  * Fix NFS renaming issues and add instructions to the README.
    Thanks to John Coiner and instructions.
  * Put all patches in debian/patches and apply them at build time.

 -- Francois Marier <francois@debian.org>  Sun, 20 May 2007 19:42:34 +1200

ccache (2.4-7) unstable; urgency=low

  * Use the real compiler when HOME is not set (closes: #396350)
  * Include user script under doc/examples (closes: #392435)
    Thanks to Behan Webster!
  * Add support for GNU --long options (closes: #297126)

 -- Francois Marier <francois@debian.org>  Sat, 18 Nov 2006 00:50:59 -0500

ccache (2.4-6) unstable; urgency=low

  * Include symlinks for gcc 4.1 (closes: #372838)
  * Update watch file

 -- Francois Marier <francois@debian.org>  Tue, 13 Jun 2006 22:17:37 -0400



=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
Uploaders: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper (>> 6), autotools-dev, zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://ccache.samba.org
Vcs-git: git://git.debian.org/git/collab-maint/ccache.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/ccache.git;a=summary

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc
Description: Compiler cache for fast recompilation of C/C++ code
 ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again. Supported languages are C, C++, Objective-C and
 Objective-C++.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
export DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
        confflags += --build $(DEB_HOST_GNU_TYPE)
else
        confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

config.status: configure-stamp
configure-stamp:
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure $(confflags) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
	touch $@

build: build-stamp
build-stamp: config.status
	dh_testdir
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f config.guess config.sub
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install prefix=$(CURDIR)/debian/ccache/usr

	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-gcc
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-g++
	set -e; for ver in 2.95 3.0 3.2 3.3 3.4 4.0 4.1 4.2 4.3 4.4; do \
		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-gcc-$$ver; \
		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/gcc-$$ver; \
		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-g++-$$ver; \
		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/g++-$$ver; \
	done
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/cc
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/c++
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/gcc
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/g++
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-c++
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-cc
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-g++
	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-gcc

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	cd debian/ccache/usr/share/doc/ccache && mv NEWS.html changelog.html
	dh_installexamples
	dh_installmenu
	dh_installcron
	dh_installman
	dh_installinfo
	dh_installchangelogs NEWS.txt
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## ccache 3.1.3

=== debian/changelog ===
ccache (3.1.3-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Thu, 02 Dec 2010 21:05:17 +0100

ccache (3.1.2-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Sun, 21 Nov 2010 21:07:27 +0100

ccache (3.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Sun, 07 Nov 2010 21:16:52 +0100

ccache (3.1-1) experimental; urgency=low

  * New upstream version.
  * It's now possible to set up ccache to hash the output of a custom
    command to identify the compiler. Closes: #506968.

 -- Joel Rosdahl <joel@debian.org>  Sat, 18 Sep 2010 19:19:07 +0200

ccache (3.0.1-2) experimental; urgency=low

  * Use dpkg triggers to automatically update symlinks in /usr/lib/ccache
    when compilers are removed or installed. Closes: #494636.
  * Update man page and manual with Debian-specific usage hints.

 -- Joel Rosdahl <joel@debian.org>  Fri, 10 Sep 2010 19:17:57 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
 Uploaders: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper (>> 6), autotools-dev, zlib1g-dev
+Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev
 Standards-Version: 3.9.1
 Homepage: http://ccache.samba.org
 Vcs-git: git://git.debian.org/git/collab-maint/ccache.git

=== debian/rules ===
--- 
+++ 
@@ -54,23 +54,7 @@
 	dh_installdirs
 
 	$(MAKE) install prefix=$(CURDIR)/debian/ccache/usr
-
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-gcc
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-g++
-	set -e; for ver in 2.95 3.0 3.2 3.3 3.4 4.0 4.1 4.2 4.3 4.4; do \
-		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-gcc-$$ver; \
-		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/gcc-$$ver; \
-		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/$(DEB_BUILD_GNU_TYPE)-g++-$$ver; \
-		ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/g++-$$ver; \
-	done
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/cc
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/c++
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/gcc
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/g++
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-c++
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-cc
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-g++
-	ln -s ../../bin/ccache $(CURDIR)/debian/ccache/usr/lib/ccache/i586-mingw32msvc-gcc
+	cp debian/update-ccache-symlinks debian/ccache/usr/sbin
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -82,13 +66,15 @@
 	dh_testroot
 	dh_installdocs
 	cd debian/ccache/usr/share/doc/ccache && mv NEWS.html changelog.html
+	cd debian/ccache/usr/share/doc/ccache && mv MANUAL.html manual.html
 	dh_installexamples
 	dh_installmenu
 	dh_installcron
-	dh_installman
+	dh_installman debian/update-ccache-symlinks.8
 	dh_installinfo
 	dh_installchangelogs NEWS.txt
 	dh_link
+	dh_lintian
 	dh_strip
 	dh_compress
 	dh_fixperms

## ccache 3.1.5

=== debian/changelog ===
ccache (3.1.5-2) unstable; urgency=low

  * Update dpkg triggers and update-ccache-symlinks to find compilers at
    the new GCC library location. Closes: #630352.
  * Use dh_prep instead of deprecated "dh_clean -k".
  * Move patches to debian directory.
  * Drop obsolete dont_distclean_version.c.patch.
  * Add build-arch and build-indep targets as hinted by lintian.

 -- Joel Rosdahl <joel@debian.org>  Sat, 25 Jun 2011 23:17:56 +0200

ccache (3.1.5-1) unstable; urgency=low

  * New upstream version.
  * Update Standards-Version to 3.9.2 (no changes required).

 -- Joel Rosdahl <joel@debian.org>  Sun, 29 May 2011 17:56:48 +0200

ccache (3.1.4-3) unstable; urgency=low

  * Fix errors in update-ccache-symlinks man page. Closes: #616619.

 -- Joel Rosdahl <joel@debian.org>  Sun, 06 Mar 2011 09:14:03 +0100

ccache (3.1.4-2) unstable; urgency=low

  * Create "gcc-X.Y"-style symlinks in /usr/lib/ccache. Closes: #610179.

 -- Joel Rosdahl <joel@debian.org>  Sun, 20 Feb 2011 16:08:06 +0100

ccache (3.1.4-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Wed, 12 Jan 2011 23:45:14 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
 Uploaders: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://ccache.samba.org
 Vcs-git: git://git.debian.org/git/collab-maint/ccache.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ccache.git;a=summary

## ccache 3.1.6

=== debian/changelog ===
ccache (3.1.6-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Sun, 21 Aug 2011 21:56:05 +0200

## ccache 3.1.7

=== debian/changelog ===
ccache (3.1.7-1) unstable; urgency=low

  * New upstream version.

 -- Joel Rosdahl <joel@debian.org>  Sun, 08 Jan 2012 22:19:24 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 # from having to guess our platform (since we know it already)
 export DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 export DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
         confflags += --build $(DEB_HOST_GNU_TYPE)
@@ -33,7 +34,9 @@
 	./configure $(confflags) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
 	touch $@
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp: config.status
 	dh_testdir
 	$(MAKE)
@@ -50,11 +53,12 @@
 install: build
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
-
+	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/ccache.triggers.in >debian/ccache.triggers
+	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/update-ccache-symlinks.in >debian/ccache/usr/sbin/update-ccache-symlinks
 	$(MAKE) install prefix=$(CURDIR)/debian/ccache/usr
-	cp debian/update-ccache-symlinks debian/ccache/usr/sbin
+	chmod +x debian/ccache/usr/sbin/update-ccache-symlinks
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -85,4 +89,5 @@
 	dh_builddeb
 
 binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install
+
+.PHONY: build build-arch build-indep clean install binary binary-indep binary-arch

## ccache 3.1.9

=== debian/changelog ===
ccache (3.1.9-1) unstable; urgency=low

  * New upstream release 3.1.9
  * Correct debian/copyright to fix Lintian errors
  * Build with hardening flags

 -- Joel Rosdahl <joel@debian.org>  Sun, 06 Jan 2013 18:19:19 +0100

ccache (3.1.8-1) unstable; urgency=low

  * New upstream release 3.1.8 (closes: #656022, #672570, #688508)
  * Update Standards-Version to 3.9.4 (no changes required)
  * Update debian/copyright to match current reality
  * Update debian/copyright to version 1.0 of the machine-readable format

 -- Joel Rosdahl <joel@debian.org>  Sun, 25 Nov 2012 12:20:16 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
 Uploaders: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
+Standards-Version: 3.9.4
 Homepage: http://ccache.samba.org
 Vcs-git: git://git.debian.org/git/collab-maint/ccache.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/ccache.git;a=summary

## ccache 3.1.10

=== debian/changelog ===
ccache (3.1.10-1) unstable; urgency=medium

  * Update Vcs-git and Vcs-Browser to use anonscm.debian.org
  * New upstream release 3.1.10
  * Switch to interest-noawait dpkg triggers (closes: #764666)
  * Bump Standards-Version to 3.9.6 (no changes)

 -- Joel Rosdahl <joel@debian.org>  Wed, 22 Oct 2014 21:20:54 +0200

=== debian/watch ===
version=2
http://samba.org/ftp/ccache/ccache-(.*)\.tar\.bz2

## ccache 3.1.12

=== debian/changelog ===
ccache (3.1.12-1) stable; urgency=medium

  * New upstream release 3.1.12 containing important bug fixes (and only
    bug fixes) made since 3.1.10:
    - Fixes a bug where (due to ccache rewriting paths) the compiler could
      choose incorrect include files if CCACHE_BASEDIR is used and the
      source file path is absolute and is a symlink. (Closes: #829088.)
    - Fixes a bug which could result in false cache hits when source code
      contains '"' followed by " /*" or " //" (with variations).
    - Makes hash of cached result created with and without CCACHE_CPP2
      different. This makes it possible to rebuild with CCACHE_CPP2 set
      without having to clear the cache to get new results.
    - Fixes a bug which could result in "No such file or directory"
      messages in the ccache log when the cache directory doesn't exist.

 -- Joel Rosdahl <joel@debian.org>  Fri, 15 Jul 2016 19:47:17 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
 Uploaders: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://ccache.samba.org
-Vcs-git: git://git.debian.org/git/collab-maint/ccache.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/ccache.git;a=summary
+Vcs-git: git://anonscm.debian.org/collab-maint/ccache.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ccache.git;a=summary
 
 Package: ccache
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)

## ccache 3.2.3

=== debian/changelog ===
ccache (3.2.3-1) unstable; urgency=medium

  * New upstream release 3.2.3
  * Use stand-alone license paragraphs in debian/copyright

 -- Joel Rosdahl <joel@debian.org>  Sun, 16 Aug 2015 15:45:28 +0200

ccache (3.2.2-2) unstable; urgency=medium

  * Correct placement of system configuration file (closes: #785409)

 -- Joel Rosdahl <joel@debian.org>  Fri, 15 May 2015 23:22:28 +0200

ccache (3.2.2-1) unstable; urgency=medium

  * New upstream release 3.2.2 (closes: #248892, #778388)
  * Update debian/copyright to match ccache 3.2.2
  * Create symlinks for clang variants in /usr/lib/ccache (closes: #624589)
  * Switch package maintainer to Joel Rosdahl

 -- Joel Rosdahl <joel@debian.org>  Sun, 10 May 2015 15:00:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ccache
 Section: devel
 Priority: optional
-Maintainer: Y Giridhar Appaji Nag <appaji@debian.org>
-Uploaders: Joel Rosdahl <joel@debian.org>
+Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
 Standards-Version: 3.9.6
 Homepage: http://ccache.samba.org

## ccache 3.2.4

=== debian/changelog ===
ccache (3.2.4-1) unstable; urgency=medium

  * New upstream release 3.2.4
  * Use debhelper compat level 9

 -- Joel Rosdahl <joel@debian.org>  Thu, 08 Oct 2015 21:48:51 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper (>> 6.0.7~), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
+Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
 Standards-Version: 3.9.6
 Homepage: http://ccache.samba.org
 Vcs-git: git://anonscm.debian.org/collab-maint/ccache.git

=== debian/rules ===
--- 
+++ 
@@ -34,7 +34,11 @@
 ifneq "$(wildcard /usr/share/misc/config.guess)" ""
 	cp -f /usr/share/misc/config.guess config.guess
 endif
-	./configure $(confflags) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
+	./configure $(confflags) \
+		--prefix=/usr \
+		--mandir=\$${prefix}/share/man \
+		--infodir=\$${prefix}/share/info \
+		--sysconfdir=/etc
 	touch $@
 
 build: build-arch build-indep

## ccache 3.2.5

=== debian/changelog ===
ccache (3.2.5-1) unstable; urgency=medium

  * New upstream release 3.2.5

 -- Joel Rosdahl <joel@debian.org>  Sun, 17 Apr 2016 16:54:25 +0200

ccache (3.2.4-2) unstable; urgency=medium

  * Create symlinks for compilers in /usr/lib/gcc-cross (closes: #815210)
  * Change http URLs to https

 -- Joel Rosdahl <joel@debian.org>  Sun, 28 Feb 2016 11:24:57 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
 Standards-Version: 3.9.6
-Homepage: http://ccache.samba.org
-Vcs-git: git://anonscm.debian.org/collab-maint/ccache.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ccache.git;a=summary
+Homepage: https://ccache.samba.org
+Vcs-git: https://anonscm.debian.org/git/collab-maint/ccache.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/ccache.git;a=summary
 
 Package: ccache
 Architecture: any

## ccache 3.2.7

=== debian/changelog ===
ccache (3.2.7-1) unstable; urgency=medium

  * New upstream release 3.2.7 (closes: #829088)
  * Bump Standards-Version to 3.9.8 (no changes)
  * Update copyright years
  * Enable pie and bindnow hardening flags

 -- Joel Rosdahl <joel@debian.org>  Wed, 20 Jul 2016 20:10:50 +0200

## ccache 3.3.3

=== debian/changelog ===
ccache (3.3.3-1) unstable; urgency=medium

  * New upstream release 3.3.3
  * Include new README.md and text version of MANUAL

 -- Joel Rosdahl <joel@debian.org>  Fri, 28 Oct 2016 00:00:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://ccache.samba.org
 Vcs-git: https://anonscm.debian.org/git/collab-maint/ccache.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/ccache.git;a=summary

## ccache 3.3.4

=== debian/changelog ===
ccache (3.3.4-1) unstable; urgency=high

  * New upstream release 3.3.4, which contains the following changes:
    * Fixes a serious regression in ccache 3.3 related to potentially bad
      content of dependency files when compiling identical source code but
      with different source paths (closes: #853834).
    * Trivial bug fix: Corrects which statistics counter to update for
      -optf/--options-file failure.
    * Trivial bug fixes: Fixes undefined behavior warnings found by
      -fsanitize=undefined.
    * Documentation update: Adds description of statistics counters to the
      man page.

 -- Joel Rosdahl <joel@debian.org>  Fri, 17 Feb 2017 23:02:40 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #export DH_VERBOSE=1
 
 DPKG_EXPORT_BUILDFLAGS = 1
+DEB_BUILD_MAINT_OPTIONS = hardening=+all
 include /usr/share/dpkg/buildflags.mk
 
 # These are used for cross-compiling and for saving the configure script

## ccache 3.4.1

=== debian/changelog ===
ccache (3.4.1-1) unstable; urgency=medium

  * New upstream release 3.4.1
  * Update location of upstream manual and changelog files
  * Update copyright to match new location of source files

 -- Joel Rosdahl <joel@debian.org>  Sun, 11 Feb 2018 19:38:13 +0100

ccache (3.3.6-1) unstable; urgency=medium

  * New upstream release 3.3.6
  * Update copyright years
  * Bump Standards-Version to 4.1.3 with no changes
  * Fix Lintian warning debian-rules-sets-dpkg-architecture-variable

 -- Joel Rosdahl <joel@debian.org>  Sun, 28 Jan 2018 19:11:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://ccache.samba.org
 Vcs-git: https://anonscm.debian.org/git/collab-maint/ccache.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/ccache.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,9 @@
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
-export DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
-export DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
-DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
         confflags += --build $(DEB_HOST_GNU_TYPE)
@@ -84,7 +84,7 @@
 	dh_installcron
 	dh_installman debian/update-ccache-symlinks.8
 	dh_installinfo
-	dh_installchangelogs NEWS.txt
+	dh_installchangelogs doc/NEWS.txt
 	dh_link
 	dh_lintian
 	dh_strip

=== debian/watch ===
version=2
https://samba.org/ftp/ccache/ccache-(.*)\.tar\.bz2

## ccache 3.4.2

=== debian/changelog ===
ccache (3.4.2-1) unstable; urgency=medium

  * New upstream release 3.4.2
  * Compensate for new doc paths in upstream release

 -- Joel Rosdahl <joel@debian.org>  Sun, 25 Mar 2018 22:41:45 +0200

## ccache 3.5

=== debian/changelog ===
ccache (3.5-1) unstable; urgency=medium

  * New upstream release 3.5
  * Update debian/copyright to match ccache's LICENSE.adoc

 -- Joel Rosdahl <joel@debian.org>  Tue, 16 Oct 2018 21:36:49 +0200

ccache (3.4.3-1) unstable; urgency=medium

  * New upstream release 3.4.3
  * Bump Standards-Version to 4.2.1 with no changes
  * Suggest icecc as an alternative to distcc (closes: #905276)
  * Install symlinks for versioned clang (closes: #867705)
  * Remove obsolete Vcs-* control fields

 -- Joel Rosdahl <joel@debian.org>  Tue, 04 Sep 2018 21:38:26 +0200

=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, zlib1g-dev, dpkg-dev (>= 1.16.1~)
Standards-Version: 4.2.1
Homepage: https://ccache.samba.org

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc | icecc
Description: Compiler cache for fast recompilation of C/C++ code
 ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again. Supported languages are C, C++, Objective-C and
 Objective-C++.
